

//  !hpf$ processors p(3, 2)
//
//  !hpf$ template t(30, 30)
//  !hpf$ distribute t(block, cyclic(10)) onto p
//
//  integer a(6, 6)
//  !hpf$ align a(i, j) with t(3 + 3 * i, 5 * j)
//
//  integer b(6)
//  !hpf$ align b(j) with t(j, *)
//
//  integer s(6)
//  !hpf$ align s(j) with t(3, 23 + j)
//
//  integer i, j
//
//  do i = 1, 6
//    do j = 1, 6
//      a(i, j) = 10 * i + j
//    enddo
//  enddo
//
//  print *, 'a...'
//  do i = 1, 6
//    print "(10i4)", a(i, : )
//  enddo
//
//  a = eoshift(a, 2, -1, 1)
//  
//  print *, 'eoshift...'
//
//  do i = 1, 6
//    print "(10i4)", a(i, : )
//  enddo
//
//  do j = 1, 6
//    b(j) = -j
//  enddo
//
//  a = eoshift(a, -2, b, 1)
//  
//  print *, 'eoshift...'
//
//  do i = 1, 6
//    print "(10i4)", a(i, : )
//  enddo
//
//  do j = 1, 6
//    s(j) = 2 - (j - 1) / 2
//  enddo
//
//  a = eoshift(a, s, -1, 2)
//
//  print *, 'eoshift...'
//
//  do i = 1, 6
//    print "(10i4)", a(i, : )
//  enddo
//
//  a = eoshift(a, -s, b, 2)
//
//  print *, 'eoshift...'
//
//  do i = 1, 6
//    print "(10i4)", a(i, : )
//  enddo
//
//end


#include <stdio.h>
#include "ad++.h"


int main(int argc, char* argv[]) {
  AdlibInit(argc, argv) ;

  Procs2 p(3, 2) ;

  BlockRange t1(30, p.dim(0)) ;
  //BlockRange t2(30, CyclicRange(3, p.dim(1))) ;
  BlockCyclicRange t2(30, p.dim(1), 10) ;

  Range a1 = t1.subrng(6, 5, 3) ;
  Range a2 = t2.subrng(6, 4, 5) ;
  Array2<int> a(a1, a2, p) ;

  Range b1 = t1.subrng(6, 0) ;
  Array1<int> b(b1, p) ;

  Range s1 = t2.subrng(6, 23) ;
  Array1<int> s(s1, p / t1(2)) ;

  Array2<int> tmp1(a1, a2, p) ;
  Array1<int> tmp2(a2, p) ;
  Array1<int> tmp3(a1, p) ;
  Array1<int> tmp4(a1, p) ;

  Index i(a1), j(a2) ;

//  do i = 1, 6
//    do j = 1, 6
//      a(i, j) = 10 * i + j
//    enddo
//  enddo

  ON(p) {
    OVERALL(i) {
      OVERALL(j) {
	a(i, j) = 10 * (a1.idx(i) + 1) + a2.idx(j) + 1 ;
      } ALLOVER(j) ;
    } ALLOVER(i) ;
  } NO(p) ;

  gprintf("a...\n") ;
  aprintf("%4d%*N", a, a2.size()) ;

//  a = eoshift(a, 2, -1, 1)

  ON(p) {
    OVERALL(i) {
      OVERALL(j) {
	tmp1(i, j) = -1 ;
      } ALLOVER(j) ;
    } ALLOVER(i) ;
  } NO(p) ;
  shift(tmp1, a, 2, 0, EDGE) ;
  copy(a, tmp1) ;

  gprintf("eoshift...\n") ;
  aprintf("%4d%*N", a, a2.size()) ;

//  do j = 1, 6
//    b(j) = -j
//  enddo

  ON(p) {
    Index k(b1) ;
    OVERALL(k) {
      b(k) = -(b1.idx(k) + 1) ;
    } ALLOVER(k) ;
  } NO(p) ;

//  a = eoshift(a, -2, b, 1)

  remap(tmp2, b) ;
  ON(p) {
    OVERALL(i) {
      OVERALL(j) {
	tmp1(i, j) = tmp2(j) ;
      } ALLOVER(j) ;
    } ALLOVER(i) ;
  } NO(p) ;
  shift(tmp1, a, -2, 0, EDGE) ;
  copy(a, tmp1) ;

  gprintf("eoshift...\n") ;
  aprintf("%4d%*N", a, a2.size()) ;

//  do j = 1, 6
//    s(j) = 2 - (j - 1) / 2
//  enddo

  Group q = s.grp() ;
  ON(q) {
    Index l(s1) ;
    OVERALL(l) {
      s(l) = 2 - s1.idx(l) / 2 ;
    } ALLOVER(l) ;
  } NO(q) ;

//  a = eoshift(a, s, -1, 2)

  remap(tmp3, s) ;

  ON(p) {
    OVERALL(i) {
      OVERALL(j) {
	tmp1(i, j) = -1 ;
      } ALLOVER(j) ;
    } ALLOVER(i) ;
  } NO(p) ;
  skew(tmp1, a, tmp3, 1, EDGE) ;
  copy(a, tmp1) ;

  gprintf("eoshift...\n") ;
  aprintf("%4d%*N", a, a2.size()) ;

//  a = eoshift(a, -s, b, 2)

  remap(tmp4, b) ;
  ON(p) {
    OVERALL(i) {
      tmp3(i) = -tmp3(i) ;
      OVERALL(j) {
	tmp1(i, j) = tmp4(i) ;
      } ALLOVER(j) ;
    } ALLOVER(i) ;
  } NO(p) ;
  skew(tmp1, a, tmp3, 1, EDGE) ;
  copy(a, tmp1) ;

  gprintf("eoshift...\n") ;
  aprintf("%4d%*N", a, a2.size()) ;

  AdlibFinalize() ;
}


